--[[
rewritten in lua by Delirius
3.4.2010
version 0.9.6
(for Creative zen X-FI 2 only)

This remake isnt intended for making profit
If you paid for it, you were scammed.
Go and demand your money back.

------------------(original authors)-----------------------
New World Computing (division of The 3DO Company)

Executive Producer: Mark Caldwell
Programming: James R. Morris II, Bob Young, George Ruof
Testing: Karl Drown, Eric Williamson, Joseph Burton, Todd Smailes, Ernie Gallardo
Producer: Peter Ryu
Art: William Chow, Steve Jasper

3DO, Arcomage, New World Computing, and their respective logos
are trademarks and/or service marks of their respective owners.
]]--


module(...,package.seeall);

-- colors
local colorWhite = color.new(255, 255, 255);
local colorOver = color.new(0,0,0,170);
local colorRed = color.new(255,0,0);

-- card used functions
function damage(who, amount)
   --print("before: tower, wall, damage", who.tower, who.wall, amount);
   if(who.wall < amount) then -- damaging wall and tower after
      local rest = amount - who.wall;
      who.wall = 0;
      who.tower = who.tower - rest;
   else  -- damaging wall only
      who.wall = who.wall - amount;
   end;
   
   --print("after:  tower, wall, damage", who.tower, who.wall, amount);
end;

-- card effects definitions
---------------------------[RED]--------------------------
function playR1(attacker, victim) -- brick shortage
   attacker.bricks = attacker.bricks - 8;
   victim.bricks = victim.bricks - 8;
end;
function playR2(attacker, victim) -- lucky cache
   attacker.bricks = attacker.bricks + 2;
   attacker.crystals = attacker.crystals + 2;
end;
function playR3(attacker, victim) -- friendly terrain
   attacker.wall = attacker.wall + 1;
end;
function playR4(attacker, victim) -- miners
   attacker.quary = attacker.quary + 1;
end;
function playR5(attacker, victim) -- mother lode
   if(attacker.quary < victim.quary) then
      attacker.quary = attacker.quary + 2;
   else
      attacker.quary = attacker.quary + 1;
   end;
end;
function playR6(attacker, victim) -- dwarven miners
   attacker.wall = attacker.wall + 4;
   attacker.quary = attacker.quary + 1;
end;
function playR7(attacker, victim) -- work overtime
   attacker.wall = attacker.wall + 5;
   attacker.crystals = attacker.crystals - 6;
end;
function playR8(attacker, victim) -- copping the tech
   if(attacker.quary < victim.quary) then
      attacker.quary = victim.quary;
   end;
end;
function playR9(attacker, victim) -- basic wall
   attacker.wall = attacker.wall + 3;
end;
function playR10(attacker, victim) -- sturdy wall
   attacker.wall = attacker.wall + 4;
end;
function playR11(attacker, victim) -- innovations
   attacker.quary = attacker.quary + 1;
   victim.quary = victim.quary + 1;
   attacker.crystals = attacker.crystals + 4;
end;
function playR12(attacker, victim) -- foundations
   if(attacker.wall == 0) then
      attacker.wall = 6;
   else
      attacker.wall = attacker.wall +3;
   end;
end;
function playR13(attacker, victim)  -- tremors
   attacker.wall = attacker.wall - 5;
   victim.wall = victim.wall - 5;
end;
function playR14(attacker, victim)  -- secret room
   attacker.magic = attacker.magic +1;
end;
function playR15(attacker, victim)  -- earthquake
   attacker.quary = attacker.quary -1;
   victim.quary = victim.quary -1;
end;
function playR16(attacker, victim)  -- big wall
   attacker.wall = attacker.wall +6;
end;
function playR17(attacker, victim)  -- collapse!
   victim.quary = victim.quary - 1;
end;
function playR18(attacker, victim)  -- new equipment
   attacker.quary = attacker.quary + 2;
end;
function playR19(attacker, victim)  -- strip mine
   attacker.quary = attacker.quary -1;
   attacker.wall = attacker.wall + 10;
   attacker.crystals = attacker.crystals +5;
end;
function playR20(attacker, victim)  -- reinforced wall
   attacker.wall = attacker.wall +8;
end;
function playR21(attacker, victim)  -- porticulus
   attacker.wall = attacker.wall +5;
   attacker.dungeon = attacker.dungeon + 1;
end;
function playR22(attacker, victim)  -- crystal rocks
   attacker.wall = attacker.wall +7;
   attacker.crystals = attacker.crystals +7;
end;
function playR23(attacker, victim)  -- harmonic ore
   attacker.wall = attacker.wall +6;
   attacker.tower = attacker.tower +3;
end;
function playR24(attacker, victim)  -- mondowall
   attacker.wall = attacker.wall +12;
end;
function playR25(attacker, victim)  -- focused designs
   attacker.wall = attacker.wall +8;
   attacker.tower = attacker.tower +5;
end;
function playR26(attacker, victim)  -- great wall
   attacker.wall = attacker.wall +15;
end;
function playR27(attacker, victim)  -- rock launcher
   attacker.wall = attacker.wall +6;
   damage(victim, 10);
end;
function playR28(attacker, victim)  -- dragons heart
   attacker.wall = attacker.wall +20;
   attacker.tower = attacker.tower +8;
end;
function playR29(attacker, victim)  -- forced labor
   attacker.wall = attacker.wall +9;
   attacker.recruits = attacker.recruits - 5;
end;
function playR30(attacker, victim)  -- rock garden
   attacker.wall = attacker.wall +1;
   attacker.tower = attacker.tower +1;
   attacker.recruits = attacker.recruits +2;
end;
function playR31(attacker, victim)  -- flod water
   if(attacker.wall < victim.wall) then
      attacker.dungeon = attacker.dungeon -1;
      attacker.tower = attacker.tower - 2;
   elseif(attacker.wall > victim.wall) then
      victim.dungeon = victim.dungeon -1;
      victim.tower = victim.tower - 2;
   else  -- walls are same height
      attacker.dungeon = attacker.dungeon -1;
      attacker.tower = attacker.tower - 2;
      victim.dungeon = victim.dungeon -1;
      victim.tower = victim.tower - 2;
   end;
end;
function playR32(attacker, victim)  -- barracks
   attacker.recruits = attacker.recruits +6;
   attacker.wall = attacker.wall +6;
   if(attacker.dungeon < victim.dungeon) then
      attacker.dungeon = attacker.dungeon +1;
   end;
end;
function playR33(attacker, victim)  -- battlements
   attacker.wall = attacker.wall +7;
   damage(victim, 6);
end;
function playR34(attacker, victim)  -- shift
   local wall = attacker.wall;
   attacker.wall = victim.wall;
   victim.wall = wall;
end;
---------------------------[BLUE]-------------------------
function playB1(attacker, victim)   -- qurtz
   attacker.tower = attacker.tower + 1;
end;
function playB2(attacker, victim)   -- smoky quartz
   victim.tower = victim.tower - 1;
end;
function playB3(attacker, victim)    -- amethyst
   attacker.tower = attacker.tower + 3;
end;
function playB4(attacker, victim)    -- spell weavers
   attacker.magic = attacker.magic + 1;
end;
function playB5(attacker, victim)    -- prism
   -- discarding 1 card and taking new
   -- after which playing again
end;
function playB6(attacker, victim)    -- lodestone
   attacker.tower = attacker.tower + 3;
end;
function playB7(attacker, victim)    -- solar flare
   attacker.tower = attacker.tower + 2;
   victim.tower = victim.tower - 2;
end;
function playB8(attacker, victim)    -- crystal matrix
   attacker.magic = attacker.magic + 1;
   attacker.tower = attacker.tower + 3;
   victim.tower = victim.tower + 1;
end;
function playB9(attacker, victim)    -- gemstone flaw
   victim.tower = victim.tower - 3;
end;
function playB10(attacker, victim)    -- ruby
   attacker.tower = attacker.tower + 5;
end;
function playB11(attacker, victim)    -- gem spear
   victim.tower = victim.tower - 5;
end;
function playB12(attacker, victim)    -- power burn
   attacker.tower = attacker.tower - 5;
   attacker.magic = attacker.magic + 2;
end;
function playB13(attacker, victim)    -- harmonic vibe
   attacker.magic = attacker.magic + 1;
   attacker.tower = attacker.tower + 3;
   attacker.wall = attacker.wall + 3;
end;
function playB14(attacker, victim)    -- parity
   if(attacker.magic < victim.magic) then
      attacker.magic = victim.magic;
   else
      victim.magic = attacker.magic;
   end;
end;
function playB15(attacker, victim)    -- emerald
   attacker.tower = attacker.tower + 8;
end;
function playB16(attacker, victim)    -- pearl of wisdom
   attacker.tower = attacker.tower + 5;
   attacker.magic = attacker.magic + 1;
end;
function playB17(attacker, victim)    -- shatter
   attacker.magic = attacker.magic - 1;
   victim.tower = victim.tower -9;
end;
function playB18(attacker, victim)    -- crumblestone
   attacker.tower = attacker.tower + 5;
   victim.bricks = victim.bricks - 6;
end;
function playB19(attacker, victim)    -- sapphire
   attacker.tower = attacker.tower + 11;
end;
function playB20(attacker, victim)    -- discord
   attacker.tower = attacker.tower -7;
   victim.tower = victim.tower -7;
   attacker.magic = attacker.magic - 1;
   victim.magic = victim.magic - 1;
end;
function playB21(attacker, victim)    -- fire ruby
   attacker.tower = attacker.tower +6;
   victim.tower = victim.tower -4;
end;
function playB22(attacker, victim)    -- quarys help
   attacker.tower = attacker.tower +7;
   attacker.bricks = attacker.bricks - 10;
end;
function playB23(attacker, victim)    -- crystal shield
   attacker.tower = attacker.tower +8;
   attacker.wall = attacker.wall +3;
end;
function playB24(attacker, victim)    -- empaty gem
   attacker.tower = attacker.tower +8;
   attacker.dungeon = attacker.dungeon +1;
end;
function playB25(attacker, victim)    -- diamond
   attacker.tower = attacker.tower +15;
end;
function playB26(attacker, victim)    -- sanctuary
   attacker.tower = attacker.tower +10;
   attacker.wall = attacker.wall +5;
   attacker.recruits = attacker.recruits +5;
end;
function playB27(attacker, victim)    -- lava jewel
   attacker.tower = attacker.tower +10;
   damage(victim, 6);
end;
function playB28(attacker, victim)    -- dragons eye
   attacker.tower = attacker.tower +20;
end;
function playB29(attacker, victim)    -- crystalize
   attacker.tower = attacker.tower +11;
   attacker.wall = attacker.wall -6;
end;
function playB30(attacker, victim)    -- bag of baubles
   if(attacker.tower < victim.tower) then
      attacker.tower = attacker.tower + 2;
   else
      attacker.tower = attacker.tower + 1;
   end;
end;
function playB31(attacker, victim)    -- rainbow
   attacker.tower = attacker.tower + 1;
   victim.tower = victim.tower + 1;
   attacker.crystals = attacker.crystals + 3;
end;
function playB32(attacker, victim)    -- apprentice
   attacker.tower = attacker.tower + 4;
   attacker.recruits = attacker.recruits -3;
   victim.tower = victim.tower -2;
end;
function playB33(attacker, victim)    -- lightning shard
   if(attacker.tower > victim.wall) then
      victim.tower = victim.tower - 8;
   else
      damage(victim, 8);
   end;
end;
function playB34(attacker, victim)    -- phase jewel
   attacker.tower = attacker.tower + 13;
   attacker.recruits = attacker.recruits + 6;
   attacker.bricks = attacker.bricks + 6;
end;
---------------------------[GREEN]------------------------
function playG1(attacker, victim)    -- mad cow disease
   attacker.recruits = attacker.recruits -6;
   victim.recruits = victim.recruits -6;
end;
function playG2(attacker, victim)    -- faerie
   damage(victim, 2);
end;
function playG3(attacker, victim)    -- moody goblins
   damage(victim, 4);
   attacker.crystals = attacker.crystals - 3;
end;
function playG4(attacker, victim)    -- minotaur
   attacker.dungeon = attacker.dungeon +1;
end;
function playG5(attacker, victim)    -- elven scout
   -- discarding 1 card and taking new
   -- after which playing again
end;
function playG6(attacker, victim)    -- goblin mob
   damage(victim, 6);
   damage(attacker, 3);
end;
function playG7(attacker, victim)    -- goblin archers
   victim.tower = victim.tower - 3;
   damage(attacker, 1);
end;
function playG8(attacker, victim)    -- shadow faerie
   victim.tower = victim.tower - 2;
end;
function playG9(attacker, victim)    -- orc
   damage(victim, 5);
end;
function playG10(attacker, victim)    -- dwaves
   damage(victim, 4);
   attacker.wall = attacker.wall + 3;
end;
function playG11(attacker, victim)    -- little snakes
   victim.tower = victim.tower - 4;
end;
function playG12(attacker, victim)    -- troll trainer
   attacker.dungeon = attacker.dungeon + 2;
end;
function playG13(attacker, victim)    -- tower gremlin
   damage(victim, 2);
   attacker.wall = attacker.wall + 4;
   attacker.tower = attacker.tower + 2;
end;
function playG14(attacker, victim)    -- full moon
   attacker.dungeon = attacker.dungeon + 1;
   victim.dungeon = victim.dungeon + 1;
   attacker.recruits = attacker.recruits + 3;
end;
function playG15(attacker, victim)    -- slasher
   damage(victim, 6);
end;
function playG16(attacker, victim)    -- ogre
   damage(victim, 7);
end;
function playG17(attacker, victim)    -- rabid sheep
   damage(victim, 6);
   victim.recruits = victim.recruits - 3;
end;
function playG18(attacker, victim)    -- imp
   damage(victim, 6);
   attacker.bricks = attacker.bricks - 5;
   attacker.crystals = attacker.crystals - 5;
   attacker.recruits = attacker.recruits - 5;
   victim.bricks = victim.bricks - 5;
   victim.crystals = victim.crystals - 5;
   victim.recruits = victim.recruits - 5;
end;
function playG19(attacker, victim)    -- spizzer
   if(victim.wall <= 0) then
      damage(victim, 10);
   else
      damage(victim, 6);
   end;
end;
function playG20(attacker, victim)    -- werewolf
   --print("werewolf");
   damage(victim, 9);
end;
function playG21(attacker, victim)    -- corrosoin cloud
   if(victim.wall > 0) then
      damage(victim, 10);
   else
      damage(victim, 7);
   end;
end;
function playG22(attacker, victim)    -- unicorn
   if(attacker.magic > victim.magic) then
      damage(victim, 12);
   else
      damage(victim, 8);
   end;
end;
function playG23(attacker, victim)    -- elven archers
   if(attacker.wall > victim.wall) then
      victim.tower = victim.tower - 6;
   else
      damage(victim, 6);
   end;
end;
function playG24(attacker, victim)    -- succubus
   victim.tower = victim.tower - 5;
   victim.recruits = victim.recruits - 8;
end;
function playG25(attacker, victim)    -- rock stompers
   damage(victim, 8);
   victim.quary = victim.quary - 1;
end;
function playG26(attacker, victim)    -- thief
   -- loot
   local crystalLoot = 5;
   local brickLoot = 3;
   
   -- amount of it
   if(victim.crystals < 10) then
      crystalLoot = math.ceil(victim.crystals/2);
   end;
   if(victim.bricks < 5) then
      brickLoot = math.ceil(victim.bricks/2);
   end;
   
   -- stealing
   victim.crystals = victim.crystals - 10;
   victim.bricks = victim.bricks - 5;

   -- adding to me
   attacker.crystals = attacker.crystals + crystalLoot;
   attacker.bricks = attacker.bricks + brickLoot;
end;
function playG27(attacker, victim)    -- stone giant
   damage(victim, 10);
   attacker.wall = attacker.wall + 4;
end;
function playG28(attacker, victim)    -- vampire
   damage(victim, 10);
   victim.recruits = victim.recruits - 5;
   victim.dungeon = victim.dungeon - 1;
end;
function playG29(attacker, victim)    -- dragon
   damage(victim, 20);
   victim.crystals = victim.crystals - 10;
   victim.dungeon = victim.dungeon - 1;
end;
function playG30(attacker, victim)    -- spearman
   --print("spearman");
   if(attacker.wall > victim.wall) then
      damage(victim, 3);
   else
      damage(victim, 2);
   end;
end;
function playG31(attacker, victim)    -- gnome
   damage(victim, 3);
   attacker.crystals = attacker.crystals + 1;
end;
function playG32(attacker, victim)    -- berserker
   damage(victim, 8);
   attacker.tower = attacker.tower - 3;
end;
function playG33(attacker, victim)    -- warlord
   damage(victim, 13);
   attacker.crystals = attacker.crystals - 3;
end;
function playG34(attacker, victim)    -- pegasus lancer
   victim.tower = victim.tower - 12;
end;

-- card definitions
cardBack = nil;   -- image of back of card
cards =
{
   R =
   {
      {value=0, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR1},   -- brick shortage
      {value=0, continuation=true, discarding=false; discardable=true; image=nil, style=0, func=playR2},   -- lucky cache
      {value=1, continuation=true, discarding=false; discardable=true; image=nil, style=0, func=playR3},   -- friendly terrain
      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR4},   -- miners
      {value=4, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR5},   -- mother lode

      {value=7, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR6},   -- dwarven miners
      {value=2, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR7},   -- work overtime
      {value=5, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR8},   -- copping the tech
      {value=2, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR9},   -- basic wall
      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR10},   -- sturdy wall

      {value=2, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR11},  -- innovations
      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR12},  -- foundations
      {value=7, continuation=true, discarding=false; discardable=true; image=nil, style=0, func=playR13},  -- tremors
      {value=8, continuation=true, discarding=false; discardable=true; image=nil, style=0, func=playR14},  -- secret room
      {value=0, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR15},  -- earthquake

      {value=5, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR16},  -- big wall
      {value=4, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR17},  -- collapse!
      {value=6, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR18},  -- new equipment
      {value=0, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR19},  -- strip mine
      {value=8, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR20},  -- reinforced wall

      {value=9, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR21},  -- porticulus
      {value=9, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR22},  -- crystal rocks
      {value=11, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR23},  -- harmonic ore
      {value=13, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR24},  -- mondowall
      {value=15, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR25},  -- focused designs

      {value=16, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR26},  -- great wall
      {value=18, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR27},  -- rock launcher
      {value=24, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR28},  -- dragons heart
      {value=7, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR29},  -- forced labor
      {value=1, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR30},  -- rock garden

      {value=6, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR31},  -- flod water
      {value=10, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR32},  -- barracks
      {value=14, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR33},  -- battlements
      {value=17, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playR34}   -- shift
   },

   B =
   {
      {value=1, continuation=true, discarding=false; discardable=true; image=nil, style=0, func=playB1},   -- qurtz
      {value=2, continuation=true, discarding=false; discardable=true; image=nil, style=0, func=playB2},   -- smoky quartz
      {value=2, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB3},   -- amethyst
      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB4},   -- spell weavers
      {value=2, continuation=true, discarding=true; discardable=true; image=nil, style=0, func=playB5},   -- prism

      {value=5, continuation=false, discarding=false; discardable=false; image=nil, style=0, func=playB6},   -- lodestone
      {value=4, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB7},   -- solar flare
      {value=6, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB8},   -- crystal matrix
      {value=2, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB9},   -- gemstone flaw
      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB10},   -- ruby

      {value=4, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB11},  -- gem spear
      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB12},  -- power burn
      {value=7, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB13},  -- harmonic vibe
      {value=7, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB14},  -- parity
      {value=6, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB15},  -- emerald

      {value=9, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB16},  -- pearl of wisdom
      {value=8, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB17},  -- shatter
      {value=7, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB18},  -- crumblestone
      {value=10, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB19},  -- sapphire
      {value=5, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB20},  -- discord

      {value=13, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB21},  -- fire ruby
      {value=4, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB22},  -- quarys help
      {value=12, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB23},  -- crystal shield
      {value=14, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB24},  -- empaty gem
      {value=16, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB25},  -- diamond

      {value=15, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB26},  -- sanctuary
      {value=17, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB27},  -- lava jewel
      {value=21, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB28},  -- dragons eye
      {value=8, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB29},  -- crystalize
      {value=0, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB30},  -- bag of baubles

      {value=0, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB31},  -- rainbow
      {value=5, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB32},  -- apprentice
      {value=11, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB33},  -- lightning shard
      {value=18, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playB34}   -- phase jewel
   },

   G =
   {
      {value=0, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG1},  -- mad cow disease
      {value=1, continuation=true, discarding=false; discardable=true; image=nil, style=0, func=playG2},  -- faerie
      {value=1, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG3},  -- moody goblins
      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG4},  -- minotaur
      {value=2, continuation=true, discarding=true; discardable=true; image=nil, style=0, func=playG5},  -- elven scout

      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG6},  -- goblin mob
      {value=4, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG7},  -- goblin archers
      {value=6, continuation=true, discarding=false; discardable=true; image=nil, style=0, func=playG8},  -- shadow faerie
      {value=3, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG9},  -- orc
      {value=5, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG10},  -- dwaves

      {value=6, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG11},  -- little snakes
      {value=7, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG12},  -- troll trainer
      {value=8, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG13},  -- tower gremlin
      {value=0, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG14},  -- full moon
      {value=5, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG15},  -- slasher

      {value=6, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG16},  -- ogre
      {value=6, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG17},  -- rabid sheep
      {value=5, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG18},  -- imp
      {value=8, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG19},  -- spizzer
      {value=9, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG20},  -- werewolf

      {value=11, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG21},  -- corrosoin cloud
      {value=9, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG22},  -- unicorn
      {value=10, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG23},  -- elven archers
      {value=14, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG24},  -- succubus
      {value=11, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG25},  -- rock stompers

      {value=12, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG26},  -- thief
      {value=15, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG27},  -- stone giant
      {value=17, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG28},  -- vampire
      {value=25, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG29},  -- dragon
      {value=2, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG30},  -- spearman

      {value=2, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG31},  -- gnome
      {value=4, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG32},  -- berserker
      {value=13, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG33},  -- warlord
      {value=18, continuation=false, discarding=false; discardable=true; image=nil, style=0, func=playG34}   -- pegasus lancer
   }
}



-- loading card subroutine
function loadCards()
   local res = image.setresource("cardsEngJpg.bin");    -- setting image bin resource

   -- back image
   cardBack = image.load("res/0000.jpg");

   -- red cards
   cards.R[1].image = image.load("res/0001.jpg");
   cards.R[2].image = image.load("res/0002.jpg");
   cards.R[3].image = image.load("res/0003.jpg");
   cards.R[4].image = image.load("res/0004.jpg");
   cards.R[5].image = image.load("res/0005.jpg");

   cards.R[6].image = image.load("res/0006.jpg");
   cards.R[7].image = image.load("res/0007.jpg");
   cards.R[8].image = image.load("res/0008.jpg");
   cards.R[9].image = image.load("res/0009.jpg");
   cards.R[10].image = image.load("res/0010.jpg");

   cards.R[11].image = image.load("res/0011.jpg");
   cards.R[12].image = image.load("res/0012.jpg");
   cards.R[13].image = image.load("res/0013.jpg");
   cards.R[14].image = image.load("res/0014.jpg");
   cards.R[15].image = image.load("res/0015.jpg");

   cards.R[16].image = image.load("res/0016.jpg");
   cards.R[17].image = image.load("res/0017.jpg");
   cards.R[18].image = image.load("res/0018.jpg");
   cards.R[19].image = image.load("res/0019.jpg");
   cards.R[20].image = image.load("res/0020.jpg");

   cards.R[21].image = image.load("res/0021.jpg");
   cards.R[22].image = image.load("res/0022.jpg");
   cards.R[23].image = image.load("res/0023.jpg");
   cards.R[24].image = image.load("res/0024.jpg");
   cards.R[25].image = image.load("res/0025.jpg");

   cards.R[26].image = image.load("res/0026.jpg");
   cards.R[27].image = image.load("res/0027.jpg");
   cards.R[28].image = image.load("res/0028.jpg");
   cards.R[29].image = image.load("res/0029.jpg");
   cards.R[30].image = image.load("res/0030.jpg");

   cards.R[31].image = image.load("res/0031.jpg");
   cards.R[32].image = image.load("res/0032.jpg");
   cards.R[33].image = image.load("res/0033.jpg");
   cards.R[34].image = image.load("res/0034.jpg");

   -- blue cards
   cards.B[1].image = image.load("res/0036.jpg");
   cards.B[2].image = image.load("res/0037.jpg");
   cards.B[3].image = image.load("res/0038.jpg");
   cards.B[4].image = image.load("res/0039.jpg");
   cards.B[5].image = image.load("res/0040.jpg");

   cards.B[6].image = image.load("res/0041.jpg");
   cards.B[7].image = image.load("res/0042.jpg");
   cards.B[8].image = image.load("res/0043.jpg");
   cards.B[9].image = image.load("res/0044.jpg");
   cards.B[10].image = image.load("res/0045.jpg");

   cards.B[11].image = image.load("res/0046.jpg");
   cards.B[12].image = image.load("res/0047.jpg");
   cards.B[13].image = image.load("res/0048.jpg");
   cards.B[14].image = image.load("res/0049.jpg");
   cards.B[15].image = image.load("res/0050.jpg");

   cards.B[16].image = image.load("res/0051.jpg");
   cards.B[17].image = image.load("res/0052.jpg");
   cards.B[18].image = image.load("res/0053.jpg");
   cards.B[19].image = image.load("res/0054.jpg");
   cards.B[20].image = image.load("res/0055.jpg");

   cards.B[21].image = image.load("res/0056.jpg");
   cards.B[22].image = image.load("res/0057.jpg");
   cards.B[23].image = image.load("res/0058.jpg");
   cards.B[24].image = image.load("res/0059.jpg");
   cards.B[25].image = image.load("res/0060.jpg");

   cards.B[26].image = image.load("res/0061.jpg");
   cards.B[27].image = image.load("res/0062.jpg");
   cards.B[28].image = image.load("res/0063.jpg");
   cards.B[29].image = image.load("res/0064.jpg");
   cards.B[30].image = image.load("res/0065.jpg");

   cards.B[31].image = image.load("res/0066.jpg");
   cards.B[32].image = image.load("res/0067.jpg");
   cards.B[33].image = image.load("res/0068.jpg");
   cards.B[34].image = image.load("res/0069.jpg");

   -- green cards
   cards.G[1].image = image.load("res/0071.jpg");
   cards.G[2].image = image.load("res/0072.jpg");
   cards.G[3].image = image.load("res/0073.jpg");
   cards.G[4].image = image.load("res/0074.jpg");
   cards.G[5].image = image.load("res/0075.jpg");

   cards.G[6].image = image.load("res/0076.jpg");
   cards.G[7].image = image.load("res/0077.jpg");
   cards.G[8].image = image.load("res/0078.jpg");
   cards.G[9].image = image.load("res/0079.jpg");
   cards.G[10].image = image.load("res/0080.jpg");

   cards.G[11].image = image.load("res/0081.jpg");
   cards.G[12].image = image.load("res/0082.jpg");
   cards.G[13].image = image.load("res/0083.jpg");
   cards.G[14].image = image.load("res/0084.jpg");
   cards.G[15].image = image.load("res/0085.jpg");

   cards.G[16].image = image.load("res/0086.jpg");
   cards.G[17].image = image.load("res/0087.jpg");
   cards.G[18].image = image.load("res/0088.jpg");
   cards.G[19].image = image.load("res/0089.jpg");
   cards.G[20].image = image.load("res/0090.jpg");

   cards.G[21].image = image.load("res/0091.jpg");
   cards.G[22].image = image.load("res/0092.jpg");
   cards.G[23].image = image.load("res/0093.jpg");
   cards.G[24].image = image.load("res/0094.jpg");
   cards.G[25].image = image.load("res/0095.jpg");

   cards.G[26].image = image.load("res/0096.jpg");
   cards.G[27].image = image.load("res/0097.jpg");
   cards.G[28].image = image.load("res/0098.jpg");
   cards.G[29].image = image.load("res/0099.jpg");
   cards.G[30].image = image.load("res/0100.jpg");

   cards.G[31].image = image.load("res/0101.jpg");
   cards.G[32].image = image.load("res/0102.jpg");
   cards.G[33].image = image.load("res/0103.jpg");
   cards.G[34].image = image.load("res/0104.jpg");
end;

-- closing loaded card images
function closeCards()
   -- back image
   cardBack:close();

   -- red cards
   cards.R[1].image:close();
   cards.R[2].image:close();
   cards.R[3].image:close();
   cards.R[4].image:close();
   cards.R[5].image:close();

   cards.R[6].image:close();
   cards.R[7].image:close();
   cards.R[8].image:close();
   cards.R[9].image:close();
   cards.R[10].image:close();

   cards.R[11].image:close();
   cards.R[12].image:close();
   cards.R[13].image:close();
   cards.R[14].image:close();
   cards.R[15].image:close();

   cards.R[16].image:close();
   cards.R[17].image:close();
   cards.R[18].image:close();
   cards.R[19].image:close();
   cards.R[20].image:close();

   cards.R[21].image:close();
   cards.R[22].image:close();
   cards.R[23].image:close();
   cards.R[24].image:close();
   cards.R[25].image:close();

   cards.R[26].image:close();
   cards.R[27].image:close();
   cards.R[28].image:close();
   cards.R[29].image:close();
   cards.R[30].image:close();

   cards.R[31].image:close();
   cards.R[32].image:close();
   cards.R[33].image:close();
   cards.R[34].image:close();

   -- blue cards
   cards.B[1].image:close();
   cards.B[2].image:close();
   cards.B[3].image:close();
   cards.B[4].image:close();
   cards.B[5].image:close();

   cards.B[6].image:close();
   cards.B[7].image:close();
   cards.B[8].image:close();
   cards.B[9].image:close();
   cards.B[10].image:close();

   cards.B[11].image:close();
   cards.B[12].image:close();
   cards.B[13].image:close();
   cards.B[14].image:close();
   cards.B[15].image:close();

   cards.B[16].image:close();
   cards.B[17].image:close();
   cards.B[18].image:close();
   cards.B[19].image:close();
   cards.B[20].image:close();

   cards.B[21].image:close();
   cards.B[22].image:close();
   cards.B[23].image:close();
   cards.B[24].image:close();
   cards.B[25].image:close();

   cards.B[26].image:close();
   cards.B[27].image:close();
   cards.B[28].image:close();
   cards.B[29].image:close();
   cards.B[30].image:close();

   cards.B[31].image:close();
   cards.B[32].image:close();
   cards.B[33].image:close();
   cards.B[34].image:close();

   -- green cards
   cards.G[1].image:close();
   cards.G[2].image:close();
   cards.G[3].image:close();
   cards.G[4].image:close();
   cards.G[5].image:close();

   cards.G[6].image:close();
   cards.G[7].image:close();
   cards.G[8].image:close();
   cards.G[9].image:close();
   cards.G[10].image:close();

   cards.G[11].image:close();
   cards.G[12].image:close();
   cards.G[13].image:close();
   cards.G[14].image:close();
   cards.G[15].image:close();

   cards.G[16].image:close();
   cards.G[17].image:close();
   cards.G[18].image:close();
   cards.G[19].image:close();
   cards.G[20].image:close();

   cards.G[21].image:close();
   cards.G[22].image:close();
   cards.G[23].image:close();
   cards.G[24].image:close();
   cards.G[25].image:close();

   cards.G[26].image:close();
   cards.G[27].image:close();
   cards.G[28].image:close();
   cards.G[29].image:close();
   cards.G[30].image:close();

   cards.G[31].image:close();
   cards.G[32].image:close();
   cards.G[33].image:close();
   cards.G[34].image:close();
end;

function getCardFromHand(hand,index)
   local set = hand[index].set;
   local ind = hand[index].ind;
   local card = nil;

   if(set == 0) then
      card = cards.R[ind];
   elseif(set == 1) then
      card = cards.B[ind];
   else
      card = cards.G[ind];
   end;

   return(card);
end;

function renderCards(hand, who)
   -- no cards?
   if(#hand < 1) then
      return;
   end;

   -- one card?
   if(#hand == 1) then
      local card = getCardFromHand(hand,1);
      card.image:draw(0,154,64,85);

      -- over blend of black if it isnt playable card
      if(playableCardFromHand(hand, 1, who) == false) then
         screen.fillrect(0, 154, 64, 85, colorOver);
      end;
      return;
   end;

   -- distance between cards
   -- card width = 64, height = 85
   local perCard = (400-64)/(#hand-1);

   -- drawing em cardzors
   for i = 1, #hand do
      -- card
      local card = getCardFromHand(hand,i);
      card.image:draw((i-1)*perCard,154,64,85);

      -- over blend of black if it isnt playable card
      if(playableCardFromHand(hand, i, who) == false) then
         screen.fillrect((i-1)*perCard, 154, 64, 85, colorOver);
      end;
   end;
end;

function selectCard(hand, x, y)
   -- too upward? or no cards
   if(y < 155 or #hand < 1) then return(0); end;

   -- one card
   if(#hand == 1 and x < 64) then
      if(x < 64) then
         return(1);
      else
         return(0);
      end;
   end;

   -- distance between cards
   -- card width = 64, height = 85
   local perCard = (400-64)/(#hand-1);

   -- getting em cardzors
   for i = #hand, 1, -1 do   -- go through hand from right to left
      if(x >= (i-1)*perCard and x <= (i-1)*perCard+64) then
         return(i);
      end;
   end;

   -- missed all cards
   return(0);
end;

function randomCard()
   -- random numbers
   local set = math.random(0,2);
   local ind = math.random(1,34);

   -- setting card
   local card = {};
   card.set=set;
   card.ind=ind;

   return(card);
end;

function randomHand(num)
   hand = {};

   for i = 1, num do
      local card = randomCard();
      --print(card);
      hand[i] = card;
   end;

   return(hand);
end;

function randomFillHandToFull(hand, num)
   -- is full?
   if(#hand >= num) then
      return;
   end;

   -- fill hand to full ammount
   local amount = num - #hand;   -- secure
   for i = #hand+1, num do
      local card = randomCard();
      --print(card);
      hand[i] = card;
   end;

   return(hand);
end;

-- returns:
-- 0 couldnt play it
-- 1 played it
-- 2 played it and continues
-- 3 played it and has to discard card and continue
function playCard(hand, index, attacker, victim)
   -- pay the price for playing card or go away
   if(payForCardFromHand(hand, index, attacker) == false) then
      return(0);
   end;

   -- play
   local card = getCardFromHand(hand,index);
   card.func(attacker, victim);

   -- remove card from hand
   removeCardFromHand(hand, index);
   
   --return value
   if(card.discarding == true) then       -- discard
      return(3)
   elseif(card.continuation == true) then -- continue
      return(2);
   else                                   -- normally played
      return(1);
   end;
end;

function removeCardFromHand(hand, index)
   table.remove(hand,index);
end;

function renderFocusedCardFromHand(hand, index, who)
   -- is card sellected
   if(index == 0) then
      text.size(20);
      text.color(colorWhite)
  	   text.draw(152, 60, "Select", "center", 248)
  	   text.draw(152, 80, "Card", "center", 248)
  	   return;
	end;

   -- card image
   card = getCardFromHand(hand, index);
   card.image:draw(152,0);

   -- over blend of black if it isnt playable card
   if(playableCardFromHand(hand, index, who) == false) then
      screen.fillrect(152, 0, 96, 128, colorOver);
      text.size(16);
      text.color(colorRed);
      text.draw(152, 30, "Not enough", "center", 248)
      text.draw(152, 45, "resources", "center", 248)
   end;

   -- discading
   if(card.discardable) then
      field.button:draw(152,128);
      text.size(16);
      text.color(colorWhite)
      text.draw(152, 131, "Discard", "center", 248)
  	end;
end;

function renderDiscardFocusedCardFromHand(hand, index, who)
   -- is card sellected
   if(index == 0) then
      text.size(20);
      text.color(colorRed)
  	   text.draw(152, 60, "Discard", "center", 248)
  	   text.draw(152, 80, "1 Card", "center", 248)
  	   return;
	end;

   -- card image
   card = getCardFromHand(hand, index);
   card.image:draw(152,0);
   screen.fillrect(152, 0, 96, 128, colorOver);

   -- need to discard
   if(card.discardable) then
      text.size(20);
      text.color(colorRed)
    	text.draw(152, 24, "Discard", "center", 248)
    	text.draw(152, 44, "1 Card", "center", 248)
   else -- undiscardble (only one such exists)
      text.size(20);
      text.color(colorRed)
    	text.draw(152, 24, "Cannot", "center", 248)
    	text.draw(152, 44, "discard", "center", 248)
  	end

   -- discading
   if(card.discardable) then
      field.button:draw(152,128);
      text.size(16);
      text.color(colorWhite)
      text.draw(152, 131, "Discard", "center", 248)
  	end;
end;

function playableCardFromHand(hand, index, who)
   local set = hand[index].set;
   local ind = hand[index].ind;

   -- resources paid by set type
   local resource = nil;
   if(set == 0) then
      resource = who.bricks;
   elseif(set == 1) then
      resource = who.crystals;
   else
      resource = who.recruits;
   end;

   -- get card
   local card = getCardFromHand(hand,index);

   -- is it possible to pay the value
   if(card.value > resource) then
      return(false);
   end;

   return(true);
end;

function payForCardFromHand(hand, index, who)
   local set = hand[index].set;
   local ind = hand[index].ind;

   -- get value of card
   local value = getCardFromHand(hand,index).value;

   -- pay the price for playing card and go away
   local resource = nil;
   if(set == 0) then
      if(who.bricks >= value) then
         who.bricks = who.bricks - value;
         return(true);
      end;
   elseif(set == 1) then
      if(who.crystals >= value) then
         who.crystals = who.crystals - value;
         return(true);
      end;
   else
      if(who.recruits >= value) then
         who.recruits = who.recruits - value;
         return(true);
      end;
   end;

   -- or return not possible to pay
   return(false);
end;

-- function making action with selected card
-- returned walues:
-- 0 no action, continue
-- 1 played or discarded, end round
-- 2 played, continue
-- 3 select card to discard, continue
function focusedCardAction(hand, index, attacker, victim, x ,y)
   -- no card sellected
   if(index <= 0) then
      return(0);
   end;

   -- checking coordinates
   if(x > 152 and x < 152+96) then
      local card = getCardFromHand(hand,index);
      if(y > 128 and y < 155) then  -- was it to discard card
         -- not discardable cards
         
         if(card.discardable == false) then
            return(0);
         end;
         -- normally discardable cards
         removeCardFromHand(hand, index);
         return(1);
      elseif(y < 128) then -- was it to play card
         --print("set, ind", hand[index].set, hand[index].ind);
         --print("karta", card.func);
         local result = playCard(hand, index, attacker, victim);
         return(result);
      end;
   end;

   -- missed card
   return(0);
end;

function focusedCardForcedDiscard(hand, index, attacker, victim, x ,y)
   -- no card sellected
   if(index <= 0) then
      return(false);
   end;

   -- checking coordinates
   if(x > 152 and x < 152+96) then
      if(y > 128 and y < 155) then  -- was it to discard card
         -- not discardable cards
         local card = getCardFromHand(hand,index);
         if(card.discardable == false) then
            return(false);
         end;
         -- normally discardable cards
         removeCardFromHand(hand, index);
         return(true);
      end;
   end;
   
   
   -- wasnt able to discard
   return(false);
end;

-- returns:
-- index when found playeble card
-- nil when no playable or no card in hand
function chooseRandomPlayableFromHand(hand, who)
   -- is hand full?
   if(#hand <= 0) then
      return(nil);
   end;

   -- check playability of all
   for i = 1, #hand do
      if(playableCardFromHand(hand, i, who) == true) then
         return(i);
      end;
   end;
   
   -- not any playable
   return(nil);
end

-- returns:
-- index when found discardable card
-- nil when no discardable or no card in hand
function chooseRandomDiscardableFromHand(hand, who)
   -- is hand full?
   if(#hand <= 0) then
      return(nil);
   end;

   -- search cards
   for i = 1, #hand do
      local card = getCardFromHand(hand,i);
      if(card.discardable == true) then
            return(i);
      end;
   end;

   -- not any discardable
   return(nil);
end

function renderEnemyMove(ePlayed, eCard)
   -- enemy
   text.size(20);
   text.color(colorRed)
  	text.draw(152, 0, "Enemy:", "center", 248)

   -- is card sellected
   if(eCard == nil) then
      text.size(20);
      text.color(colorRed)
  	   text.draw(152, 80, "Impossible", "center", 248)
  	   text.draw(152, 100, "to move", "center", 248)
  	   return;
	end;

   -- card image
   if(ePlayed == true) then   -- card was played
      eCard.image:draw(152,23);
      text.size(20);
      text.color(colorRed)
    	text.draw(152, 60, "played", "center", 248)
   else  -- card was discarded
      cardBack:draw(152,23);
      text.size(20);
      text.color(colorRed)
    	text.draw(150, 75, "discarded", "center", 250)
   end;
end;

function enemyRandomDiscard(hand, enemy)
   -- chosen card
   local card = nil;
   
   -- get random discardable
   local disCard = chooseRandomDiscardableFromHand(hand, enemy);
   if(disCard ~= nil) then -- discard card
      card = getCardFromHand(hand,disCard);
      removeCardFromHand(hand, disCard);
   end

   -- return discarded card
   return(card);
end;

function enemyRandomMove(hand, enemy, player, rules)
   -- returned played card
   local card = nil;
   local played = false;
   local continuePlay = true;
   
   -- choose playable card from hand
   local index = chooseRandomPlayableFromHand(hand, enemy);
   
   if(index ~= nil) then -- play card
      card = getCardFromHand(hand, index);
      local result = playCard(hand, index, enemy, player);
      -- card played
      played = true;
      
      -- returns:
      -- 0 couldnt play it
      -- 1 played it
      -- 2 played it and continues
      -- 3 played it and has to discard card and continue
      
      if(result == 0) then       -- 0 no action, continue
         continuePlay = false;
      elseif(result == 1) then   -- 1 played or discarded, end round
         continuePlay = false;
      elseif(result == 2) then   -- 2 played, continue
         continuePlay = true;
      else                       -- 3 select card to discard, continue
         continuePlay = true;
      end;
      
   else                 -- discard some and end
      card = enemyRandomDiscard(hand, enemy);
      continuePlay = false; -- end round
   end
   
   -- return card enemy has played
   return played, continuePlay, card;
end;

function enemyAgresiveMove(hand, enemy, player, rules)

   -- return card enemy has played
   local r1;
   local r2;
   local r3;
   r1, r2, r3 = enemyRandomMove(hand, enemy, player, rules);
   return r1, r2, r3;
end;

function enemyDefensiveMove(hand, enemy, player, rules)

   -- return card enemy has played
   local r1;
   local r2;
   local r3;
   r1, r2, r3 = enemyRandomMove(hand, enemy, player, rules);
   return r1, r2, r3;
end;
