--[[
rewritten in lua by Delirius
3.4.2010
version 0.9.6
(for Creative zen X-FI 2 only)

This remake isnt intended for making profit
If you paid for it, you were scammed.
Go and demand your money back.

------------------(original authors)-----------------------
New World Computing (division of The 3DO Company)

Executive Producer: Mark Caldwell
Programming: James R. Morris II, Bob Young, George Ruof
Testing: Karl Drown, Eric Williamson, Joseph Burton, Todd Smailes, Ernie Gallardo
Producer: Peter Ryu
Art: William Chow, Steve Jasper

3DO, Arcomage, New World Computing, and their respective logos
are trademarks and/or service marks of their respective owners.
]]--


module(...,package.seeall);

-- colors
local colorWhite = color.new(255, 255, 255);
local colorYellow = color.new(255, 255, 0);
local colorBlack = color.new(0, 0, 0);

-- field definition
background = nil;
button = nil;
resources = nil;
tower1 = nil;
tower2 = nil;
wall = nil;

-- loading card subroutine
function loadFieldImages()
   -- setting resource bin
   res = image.setresource("layout.bin");
   -- loading appropriate images
   background = image.load("res/layout.jpg");
   button = image.load("res/button.jpg");
   resources = image.load("res/resources.jpg");
   tower1 = image.load("res/tower1.png");
   tower2 = image.load("res/tower2.png");
   wall = image.load("res/wall.png");
end;

-- closing loaded card images
function closeFieldImages()
   -- closing all field images
   background:close();
   button:close();
   resources:close();
   tower1:close();
   tower2:close();
   wall:close();
end;

function renderField(player, enemy)
   -- images
   background:draw(0,0);
   resources:draw(0,0);
   resources:draw(400-55,0);
   
   -- resource generators
   text.size(18);
   text.color(colorYellow);
   text.draw(0, 11, player.quary, "center", 25);
   text.draw(0, 60, player.magic, "center", 25);
   text.draw(0, 112, player.dungeon, "center", 25);
   text.draw(346, 11, enemy.quary, "center", 371);
   text.draw(346, 60, enemy.magic, "center", 371);
   text.draw(346, 112, enemy.dungeon, "center", 371);

   -- resources
   text.size(10);
   text.color(colorBlack);
   text.draw(30, 40, player.bricks, "center", 55);
   text.draw(30, 90, player.crystals, "center", 55);
   text.draw(30, 141, player.recruits, "center", 55);
   text.draw(375, 40, enemy.bricks, "center", 400);
   text.draw(375, 90, enemy.crystals, "center", 400);
   text.draw(375, 141, enemy.recruits, "center", 400);
end;

function renderTowersAndWalls(player, enemy, rules)
   -- mximas
   local maxHeight = 155;
   local towerWidth = 68;
   local towerTop = 62;
   local wallWidth = 24;
   local effectiveHeight = maxHeight-towerTop;
   
   --rules.maxTower;
   --rules.maxWall;
   
   -- player
   local pixels = player.tower / rules.maxTower * effectiveHeight;
   drawtile(tower1,56,effectiveHeight-pixels,0,0,towerWidth,towerTop+pixels);
   
   pixels = player.wall / rules.maxWall * effectiveHeight;
   drawtile(wall,125,towerTop+effectiveHeight-pixels,0,0,wallWidth,pixels);
   
   -- enemy
   local pixels = enemy.tower / rules.maxTower * effectiveHeight;
   drawtile(tower2,276,effectiveHeight-pixels,0,0,towerWidth,towerTop+pixels);

   pixels = enemy.wall / rules.maxWall * effectiveHeight;
   drawtile(wall,251,towerTop+effectiveHeight-pixels,0,0,wallWidth,pixels);
   
   -- text
   text.size(14);
   text.color(colorWhite);
   text.draw(56, 140, player.tower, "center", 56+towerWidth);
   text.draw(120, 140, player.wall, "center", 125+24+5);
   text.draw(276, 140, enemy.tower, "center", 276+towerWidth);
   text.draw(251-5, 140, enemy.wall, "center", 251+5+24);
end;

-------------------------------[drawing one tile]-------------------------------
-- standart creative image:draw is weird:
-- (against their own specification in pdf)
-- image:draw(x,y,imx,imy,imw,imh)
-- x, y = offset of image on screen (where would be left upper corner of full image positioned on screen)
-- imx, imy = screen coordinates of upper left corner of scissor rectangle
-- imw, imh = width and height of scissor rectangle

-- (this is by their specifications)
-- my function is different:
-- x,y are coords of image part on screen
-- imx, imy are coords of upper left corner of part in image coord system
-- imw, imh are width and height of part cut from image
function drawtile(image,x,y,imx,imy,imw,imh)
   image:draw(x-imx,y-imy,x,y,imw,imh)
end
