--[[
rewritten in lua by Delirius
10.4.2010
version 1.0.1
(for Creative zen X-FI 2 only)

This remake isnt intended for making profit
If you paid for it, you were scammed.
Go and demand your money back.

------------------(original authors)-----------------------
New World Computing (division of The 3DO Company)

Executive Producer: Mark Caldwell
Programming: James R. Morris II, Bob Young, George Ruof
Testing: Karl Drown, Eric Williamson, Joseph Burton, Todd Smailes, Ernie Gallardo
Producer: Peter Ryu
Art: William Chow, Steve Jasper

3DO, Arcomage, New World Computing, and their respective logos
are trademarks and/or service marks of their respective owners.
]]--

--includes
package.loaded.Gui = nil;
require "Gui";

module(...,package.seeall);

---------------------[immages and settings]-------------------------
background = nil;    -- menu background
title = nil;         --arcomage title
buttonImage = nil;   --menu button
buttonPressed = nil; --menu button pressed
tavernMap = nil;     --tavern presets map

---------------------[immages and settings]-------------------------
colorWhite = color.new(255,255,255);
colorYellow = color.new(255,200,0);

---------------------------[functions]------------------------------
function splashScreen()
   -- loading images
   res = image.setresource("menu.bin");
   background = image.load("res/background.jpg");
   title = image.load("res/title.png");
   
   --drawing
   background:draw(0,0);
   title:draw(0,50);
   
   --writing
   text.size(20);
   text.color(color.new(255,200,0));
   text.draw(0, 150, "Loading...", "center", 400)
   screen.update();
   --os.wait(1000);
end;

function loadImages()
   --loading images
   res = image.setresource("menu.bin");
   buttonImage = image.load("res/button.jpg");
   buttonPressed = image.load("res/button2.jpg");
   tavernMap = image.load("res/taverns.jpg");
   
   -- button backgrounds
   B1.pix=buttonImage;
   B2.pix=buttonImage;
   B3.pix=buttonImage;
   B4.pix=buttonImage;
   B5.pix=buttonImage;
   B6.pix=buttonImage;
   B1.pix2=buttonPressed;
   B2.pix2=buttonPressed;
   B3.pix2=buttonPressed;
   B4.pix2=buttonPressed;
   B5.pix2=buttonPressed;
   B6.pix2=buttonPressed;
   Byes.pix=buttonImage;
   Bno.pix=buttonImage;
   Byes.pix2=buttonPressed;
   Bno.pix2=buttonPressed;
   Bcancel.pix=buttonImage;
   Bcancel.pix2=buttonPressed;
   Bok.pix=buttonImage;
   Bok.pix2=buttonPressed;
   
   --NG1,NG2,NG3,NG4,NG5,NG6,NG7,NG8,NG9,NG10,NG11,NG12,NG13,NG14,
   NG1.pix=buttonImage;
   NG1.pix2=buttonPressed;
   NG2.pix=buttonImage;
   NG2.pix2=buttonPressed;
   NG3.pix=buttonImage;
   NG3.pix2=buttonPressed;
   NG4.pix=buttonImage;
   NG4.pix2=buttonPressed;
   NG5.pix=buttonImage;
   NG5.pix2=buttonPressed;
   NG6.pix=buttonImage;
   NG6.pix2=buttonPressed;
   NG7.pix=buttonImage;
   NG7.pix2=buttonPressed;
   NG8.pix=buttonImage;
   NG8.pix2=buttonPressed;
   NG9.pix=buttonImage;
   NG9.pix2=buttonPressed;
   NG10.pix=buttonImage;
   NG10.pix2=buttonPressed;
   NG11.pix=buttonImage;
   NG11.pix2=buttonPressed;
   NG12.pix=buttonImage;
   NG12.pix2=buttonPressed;
   NG13.pix=buttonImage;
   NG13.pix2=buttonPressed;
   NG14.pix=buttonImage;
   NG14.pix2=buttonPressed;
   NGBACK.pix=buttonImage;
   NGBACK.pix2=buttonPressed;
   NGSTART.pix=buttonImage;
   NGSTART.pix2=buttonPressed;
end;

function closeImages()
   background:close();
   title:close();
   buttonImage:close();
   buttonPressed:close();
   tavernMap:close();
end;

-----------------------------[menus]--------------------------------
function returnIndex(btn)
   return(btn.id);
end

B1 = {id=1, name="new game",x=50,y=100,width=140,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
B2 = {id=2, name="continue",x=210,y=100,width=140,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
B3 = {id=3, name="instructions",x=50,y=145,width=140,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
B4 = {id=4, name="highscore",x=210,y=145,width=140,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
B5 = {id=5, name="settings",x=50,y=190,width=140,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
B6 = {id=6, name="exit",x=210,y=190,width=140,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}

-- main menu stuff
mainMenu = {xShift=0, yShift=0,
         buttons={B1,B2,B3,B4,B5,B6}}

function mainMenuFunction(x,y)
	-- execute menu function callback
	local keyOut = Gui.menuFunction(x,y, mainMenu)
	return(keyOut)
end

function mainMenuRender()
   -- render background
   background:draw(0,0);
   title:draw(0,0);

   -- write D
   text.size(12);
   text.color(color.new(255,200,0));
   text.draw(0, 225, "Rewriten by Delirius. Original game and graphics by 3DO", "center", 400)

   -- render menu
   Gui.menuRender(mainMenu)
end

------------------------------------------[new game menu]---------------------

NG1 = {id=1, name="1",x=0,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG2 = {id=2, name="2",x=28,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG3 = {id=3, name="3",x=56,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG4 = {id=4, name="4",x=84,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG5 = {id=5, name="5",x=112,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG6 = {id=6, name="6",x=140,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG7 = {id=7, name="7",x=168,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG8 = {id=8, name="8",x=196,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG9 = {id=9, name="9",x=224,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG10 = {id=10, name="10",x=252,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG11 = {id=11, name="11",x=280,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG12 = {id=12, name="12",x=308,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG13 = {id=13, name="13",x=336,y=0,width=28,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NG14 = {id=14, name="U",x=364,y=0,width=36,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NGBACK = {id=15, name="back",x=100,y=200,width=90,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
NGSTART = {id=16, name="start",x=210,y=200,width=90,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}

newGameMenu = {xShift=0, yShift=0,
         buttons={NG1,NG2,NG3,NG4,NG5,NG6,NG7,NG8,NG9,NG10,NG11,NG12,NG13,NG14,NGBACK,NGSTART}}

local selectedTavernIndex = 1;

function newGameMenuFunction(x,y)
	-- execute menu function callback
	local keyOut = Gui.menuFunction(x,y, newGameMenu)
	if(keyOut == 0 or keyOut == nil) then
      return(nil);
	elseif(keyOut == 15) then --go back to menu
      return(0);
	elseif(keyOut == 16) then --go
      if(selectedTavernIndex == 14) then --user defined rules
         return(nil);
      else
         return(selectedTavernIndex);
      end;
	else       --selected tavern
      selectedTavernIndex = keyOut;
	end;
	
	return(nil);
end

function newGameMenuRender()
   -- render background
   tavernMap:draw(0,0);
   screen.fillrect(0,0,400,240,color.new(0,0,0,150));

   -- description of tavern rules
   text.size(20);
   text.color(colorYellow);
   
   if(selectedTavernIndex == 14) then  -- user defined rules
      text.draw(0, 50, "User defined rules", "center", 400)
      text.draw(0, 70, "Not Yet Available", "center", 400)
   else  -- other tavern
      text.draw(0, 40, "("..selectedTavernIndex..") "..taverns.taverns[selectedTavernIndex].name, "center", 400)

      text.size(12);
      text.color(colorWhite);
      text.draw(0, 60, "("..taverns.taverns[selectedTavernIndex].location..")", "center", 400)
      
      text.size(14);
      -- tower
      text.color(colorYellow);
      text.draw(20, 80, "[Tower]", "left", 400)
      text.color(colorWhite);
      text.draw(20, 95, "start: "..taverns.taverns[selectedTavernIndex].tower, "left", 400)
      text.draw(20, 110, "target: "..taverns.taverns[selectedTavernIndex].maxTower, "left", 400)
      
      -- wall
      text.color(colorYellow);
      text.draw(20, 140, "[Wall]", "left", 400)
      text.color(colorWhite);
      text.draw(20, 155, "start: "..taverns.taverns[selectedTavernIndex].wall, "left", 400)
      text.draw(20, 170, "max: 100", "left", 400)
      
      -- resources
      text.color(colorYellow);
      text.draw(150, 80, "[Resources]", "left", 400)
      text.color(colorWhite);
      text.draw(150, 95, "bricks: "..taverns.taverns[selectedTavernIndex].bricks, "left", 400)
      text.draw(150, 110, "crystals: "..taverns.taverns[selectedTavernIndex].crystals, "left", 400)
      text.draw(150, 125, "recruits: "..taverns.taverns[selectedTavernIndex].recruits, "left", 400)
      
      text.color(colorYellow);
      text.draw(280, 80, "[Generators]", "left", 400)
      text.color(colorWhite);
      text.draw(280, 95, "quary: "..taverns.taverns[selectedTavernIndex].quary, "left", 400)
      text.draw(280, 110, "magic: "..taverns.taverns[selectedTavernIndex].magic, "left", 400)
      text.draw(280, 125, "dungeon: "..taverns.taverns[selectedTavernIndex].dungeon, "left", 400)
      
      -- target resources ammount
      text.color(colorYellow);
      text.draw(125, 155, "[Res. target]", "left", 400)
      text.color(colorWhite);
      text.draw(125, 170, taverns.taverns[selectedTavernIndex].maxResources, "left", 400)

      -- enemy ai
      -- 0 = random
      -- 1 = agresive
      -- 2 = defensive
      text.color(colorYellow);
      text.draw(225, 155, "[Enemy AI]", "left", 400)
      text.color(colorWhite);
      if(taverns.taverns[selectedTavernIndex].ai == 0) then
         text.draw(225, 170, "random", "left", 400)
      elseif(taverns.taverns[selectedTavernIndex].ai == 1) then
         text.draw(225, 170, "agresive", "left", 400)
      else
         text.draw(225, 170, "defensive", "left", 400)
      end;

      -- number of cards in hand
      text.color(colorYellow);
      text.draw(325, 155, "[Cards]", "left", 400)
      text.color(colorWhite);
      text.draw(325, 170, taverns.taverns[selectedTavernIndex].cards, "left", 400)

   end;

   -- render menu
   Gui.menuRender(newGameMenu)
end

-----------------------------[end game stuff]-----------------------------

function showEndGame(victory, timeNow, movesNow)
   if(victory ~= nil) then

      -- write on screen cause of gameover
      background:draw(0,0);
      title:draw(0,50);
      text.size(20);
      text.color(color.new(255,200,0));
      text.draw(0, 150, victory, "center", 400)

      -- time taken and moves executed
      text.draw(0,170,"Time : "..timeNow.." seconds","center",400);
      text.draw(0,190,"Moves : "..movesNow.." executed","center",400);

      -- change buffers
      screen.update();

      -- touch to continue
      waitForAction();
   end;
end;

function showInstructions()
   res = image.setresource("instructions.bin");

   -- first screen
   gamemenus.background:draw(0,0);
   text.size(20);
   text.color(color.new(255,200,0));
   screen.fillrect(0,0,400,240,color.new(0,0,0,150));
   text.draw(0, 10, "instructions", "center", 400)
   text.size(13);
   text.draw(0, 45, "Arcomage is fantasy card game against computer enemy.", "center", 400);
   text.draw(0, 60, "Player's goal is to destroy tower of the enemy,", "center", 400);
   text.draw(0, 75, "build his tower to target height or gather", "center", 400);
   text.draw(0, 90, "target ammount of all resources. Player looses", "center", 400);
   text.draw(0, 105, "if enemy accomplishes any of these goals before player.", "center", 400);
   text.draw(0, 140, "Player and enemy are taking turns in playing cards.", "center", 400);
   text.draw(0, 155, "Cards have various effects, such as building tower,", "center", 400);
   text.draw(0, 170, "building wall, changing ammount of resources", "center", 400);
   text.draw(0, 185, "or resource generators, damaging enemy tower or wall.", "center", 400);
   text.size(15);
   text.color(color.new(255,100,0));
   text.draw(0,224,"(Click to continue)","center",400);
   screen.update();  -- change back-buffer
   waitForAction();  -- touch to continue

--[[
   -- second screen
   local im1 = image.load("res/1.jpg");
   im1:draw(0,0);
   im1:close();
   text.size(20);
   text.color(color.new(255,200,0));
   text.draw(0, 10, "playing area", "center", 400)
   text.size(13);
   text.draw(0, 45, "player tower", "center", 400);
   screen.fillrect(125,223,150,20,color.new(0,0,0,150));
   text.size(15);
   text.color(color.new(255,100,0));
   text.draw(0,224,"(Click to continue)","center",400);
   screen.update();  -- change back-buffer
   waitForAction();  -- touch to continue
]]--
   
   -- third screen
   gamemenus.background:draw(0,0);
   text.size(20);
   text.color(color.new(255,200,0));
   screen.fillrect(0,0,400,240,color.new(0,0,0,200));
   text.draw(0, 10, "resources", "center", 400)
   text.size(13);
   text.draw(0, 45, "Every card cost appropriate amount of \"bricks\", \"gems\"", "center", 400);
   text.draw(0, 60, "or \"recruits\". At the beginning of turn, ammount of each", "center", 400);
   text.draw(0, 75, "resource is generated  by \"quary\", \"magic\"", "center", 400);
   text.draw(0, 90, "and \"dungeon\" respectively.", "center", 400);
   text.size(15);
   text.color(color.new(255,100,0));
   text.draw(0,224,"(Click to continue)","center",400);
   screen.update();  -- change back-buffer
   waitForAction();  -- touch to continue

--[[
   -- fourth screen
   local im1 = image.load("res/1.jpg");
   im1:draw(0,0);
   im1:close();
   
   text.size(15);
   text.color(color.new(255,100,0));
   text.draw(0,224,"(Click to continue)","center",400);
   screen.update();  -- change back-buffer
   waitForAction();  -- touch to continue
   
   
   
   
   text.size(15);
   text.color(color.new(255,100,0));
   text.draw(0,224,"(Click to exit)","center",400);
   screen.update();  -- change back-buffer
   waitForAction();  -- touch to continue
]]--
end;

function showHighscore()
   -- background
   gamemenus.tavernMap:draw(0,0);
   screen.fillrect(0,0,400,240,color.new(0,0,0,150));

   -- table headers
   text.size(16);
   text.color(color.new(255,100,0));
   
   text.draw(20, 3, "Tavern", "center", 100);
   text.draw(200, 3, "Rounds", "center", 300);
   text.draw(300, 3, "Time", "center", 400);

   text.size(12);
   text.color(color.new(250,200,0));

   -- for taverns
   for i = 1, #taverns.taverns do
      -- tavern name
      text.draw(20, 20+15*(i-1), taverns.taverns[i].name, "left", 400);
      -- moves executed and time taken
      text.draw(200,20+15*(i-1),taverns.taverns[i].tower,"center",300);
      text.draw(300,20+15*(i-1),taverns.taverns[i].tower,"center",400);
   end;

   -- user settings highscore
   text.draw(20, 20+15*#taverns.taverns, "User settings", "left", 400);
   text.draw(200,20+15*#taverns.taverns, 999,"center",300);
   text.draw(300,20+15*#taverns.taverns, 999,"center",400);
   
   -- click to continue
   text.size(10);
   text.color(color.new(255,100,0));
   text.draw(0,229,"(Click to continue)","center",400);

   -- change buffers
   screen.update();

   -- touch to continue
   waitForAction();
end;

function waitForAction()
   while true do
      if(control.read()==1) then
         -- touch screen event
         if(control.isTouch()==1) then
			   if(touch.click()==1) then
               break
            end;
         else
            if(button.home() == 1) then
               if(button.click()==1) then
                  break;
               end;
            end;
         end;
      else
         os.wait(100);
      end;
   end;
end;

-----------------------------------[save dialogbox]------------------------------
Bcancel = {id=3, name="back",x=30,y=180,width=90,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
Byes = {id=1, name="save&quit",x=140,y=180,width=120,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}
Bno = {id=2, name="quit",x=280,y=180,width=90,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}

-- char keyboard
saveMenu = {xShift=0, yShift=0,
         buttons={Bcancel,Byes,Bno}}

function saveMenuFunction(x,y)
	-- optimalization
	if(y < 160) then
		return(nil)
	end

	-- execute menu function callback
	local keyOut = Gui.menuFunction(x,y, saveMenu)
	return(keyOut)
end

function saveMenuRender()
   -- render menu
   Gui.menuRender(saveMenu)
end

--returns:
-- 0 .. no quiting (cancelled)
-- 1 .. save and quit
-- 2 .. just quit
function saveMenuLoop(timeNow, movesNow, rules)

   -- render background blackness
   screen.fillrect(0,0,400,240,color.new(0,0,0,200));

   -- write PAUSED
   text.size(18);
   text.color(color.new(255,0,0));
   text.draw(0, 20, "PAUSED", "center", 400)
   
   -- tavern name
   text.color(colorYellow);
   text.draw(0, 50, "("..rules.tavern..") "..taverns.taverns[rules.tavern].name, "center", 400)

   -- rules
   text.size(14);
   text.color(colorYellow);
   text.draw(0, 80, "[Rules]", "center", 200)

   text.size(14);
   -- tower target size
   text.color(colorWhite);
   text.draw(0, 100, "Tower target: "..rules.maxTower, "center", 200)

   -- target resources ammount
   text.draw(0, 120, "Res. target: "..rules.maxResources, "center", 200)

   -- enemy ai
   text.color(colorWhite);
   if(rules.enemyTactics == 0) then
      text.draw(0, 140, "AI: random", "center", 200)
   elseif(rules.enemyTactics == 1) then
      text.draw(0, 140, "AI: agresive", "center", 200)
   else
      text.draw(0, 140, "AI: defensive", "center", 200)
   end;
   
   -- statistics
   text.color(colorYellow);
   text.draw(200, 80, "[Stats]", "center", 400)
   
   -- time played
   text.color(colorWhite);
   text.draw(200, 100, "Elapsed time: "..timeNow.."s", "center", 400)

   -- moves executed
   text.draw(200, 120, "Executed moves : "..movesNow, "center", 400)
   
   -- info about saving
   text.color(colorYellow);
   text.draw(0, 210, "(saving will overwrite last save position)", "center", 400)

   -- loop for user reaction
   while true do
      if(control.read()==1) then
	    -- touch screen event
         if(control.isTouch()==1) then
            if(touch.click()==1) then
               x,y = touch.pos()
               local returnedButton = saveMenuFunction(x,y);
               print("save",returnedButton);
               if(returnedButton == 1) then
                  return(1);
               elseif(returnedButton == 2) then
                  return(2);
               elseif(returnedButton == 3) then
                  return(0);
               end
			   end;
         else
            if(button.home() == 1) then
               if(button.click()==1) then
                  return(0);
               end;
            end;
         end;
      else

      saveMenuRender();
      screen.update();

      -- spare some time for other programs
	  os.wait(100);

      end;
   end;
end;

-----------------------------------[no continue box]------------------------------
Bok = {id=1, name="ok",x=155,y=130,width=90,height=30,used=0,pix=nil,pix2=nil,style=2,func=returnIndex}

-- char keyboard
loadMenu = {xShift=0, yShift=0,
         buttons={Bok}}

function loadMenuFunction(x,y)
	-- optimalization for charboard
	if(y < 130) then
		return(nil)
	end

	-- execute menu function callback
	local keyOut = Gui.menuFunction(x,y, loadMenu)
	return(keyOut)
end

function loadMenuRender()
   -- render menu
   Gui.menuRender(loadMenu)
end

function loadMenuLoop()

   -- render background blackness
   screen.fillrect(0,0,400,240,color.new(0,0,0,200));

   -- write D
   text.size(16);
   text.color(color.new(255,200,0));
   text.draw(0, 95, "You have no saved game to continue", "center", 400)

   while true do
      if(control.read()==1) then
	    -- touch screen event
         if(control.isTouch()==1) then
            if(touch.click()==1) then
               x,y = touch.pos()
               local returnedButton = loadMenuFunction(x,y);
               print("save",returnedButton);
               if(returnedButton == 1) then
                  return(1);
               end
			   end;
         else
            if(button.home() == 1) then
               if(button.click()==1) then
                  return(0);
               end;
            end;
         end;
      else

      loadMenuRender();
      screen.update();

      -- spare some time for other programs
	  os.wait(100);

      end;
   end;
end;
