--[[
rewritten in lua by Delirius
3.4.2010
version 0.9.6
(for Creative zen X-FI 2 only)

This remake isnt intended for making profit
If you paid for it, you were scammed.
Go and demand your money back.

------------------(original authors)-----------------------
New World Computing (division of The 3DO Company)

Executive Producer: Mark Caldwell
Programming: James R. Morris II, Bob Young, George Ruof
Testing: Karl Drown, Eric Williamson, Joseph Burton, Todd Smailes, Ernie Gallardo
Producer: Peter Ryu
Art: William Chow, Steve Jasper

3DO, Arcomage, New World Computing, and their respective logos 
are trademarks and/or service marks of their respective owners.
]]--


--includes
package.loaded.gamemenus = nil;
require "gamemenus";
package.loaded.cards = nil;
require "cards";
package.loaded.field = nil;
require "field";
package.loaded.taverns = nil;
require "taverns";
package.loaded.timer = nil;
require "timer";

-------------------------------------------------------------------
swidth  = screen.width()
sheight = screen.height()
local black = color.new(0,0,0)
local colorWhite = color.new(255, 255, 255);
local colorYellow = color.new(255, 255, 0);

---------------------------[splash screen]-------------------------
gamemenus.splashScreen();

---------------------------[settings]-------------------------

-- settings
player = {quary = 2, bricks = 10, magic = 2, crystals = 10, dungeon = 2, recruits = 10, wall = 20, tower = 25};
enemy  = {quary = 2, bricks = 10, magic = 2, crystals = 10, dungeon = 2, recruits = 10, wall = 20, tower = 25};
rules  = {tavern=0, maxTower = 50, maxWall = 100, maxResources = 100, numCards=6, enemyTactics=0};

-- load presets(1-13)
--taverns.loadTavernSettings(player, enemy, rules, 9);
--print(rules.maxTower, rules.maxWall, rules.maxResources, rules.numCards, rules.enemyTactics);

-- hands
playerHand = {};--cards.randomHand(rules.numCards);
enemyHand = {};--cards.randomHand(rules.numCards);

-- state variables
focusedCard = 0;        -- card currnetly sellected by player
forcedDiscard = false;  -- for cards that make u discard orhers
roundEnd = false;       -- for ending after discard
victory = nil;          -- string with victory quote, when game over
moves = 0;              -- number of moves till end
enemyShowTime = 1000;   -- how long will be shown enemy move on screen

--------------------------[images from bin]------------------------
gamemenus.loadImages();
cards.loadCards();
field.loadFieldImages();
math.randomseed(os.time());
math.randomseed(os.time()*math.random());
--cards.randomCard();

-----------------------[application functions]----------------------
function saveGame()
   -- opening file
   local FILEsave = io.open("save.lua","w+")
   --print(FILEsave);
   
   -- succeded in opening file?
   if (FILEsave ~= nil) then
      -- saving player stats
      FILEsave:write("Player stats\n");
      FILEsave:write(player.quary,", ", player.bricks,", ", player.magic,", ", player.crystals,", ", player.dungeon,", ", player.recruits,", ", player.wall,", ", player.tower,"\n");

      -- saving enemy stats
      FILEsave:write("Enemy stats\n");
  	   FILEsave:write(enemy.quary,", ", enemy.bricks,", ", enemy.magic,", ", enemy.crystals,", ", enemy.dungeon,", ", enemy.recruits,", ", enemy.wall,", ", enemy.tower,"\n");

      -- rules
      FILEsave:write("Rules\n");
      FILEsave:write(rules.tavern,", ", rules.maxTower,", ", rules.maxWall,", ", rules.maxResources,", ", rules.numCards,", ", rules.enemyTactics,"\n");

      -- hand of player
      FILEsave:write("Cards in player hand\n");
  	   for i = 1,#playerHand do
         FILEsave:write(playerHand[i].set,", ",playerHand[i].ind,"\n");
  	   end;

      -- hand of enemy
      FILEsave:write("Cards in enemy hand\n");
  	   for i = 1,#enemyHand do
         FILEsave:write(enemyHand[i].set,", ",enemyHand[i].ind,"\n");
  	   end;

      -- miscelanous
      FILEsave:write("Miscelanous\n");
      FILEsave:write(moves,"\n");
  	   FILEsave:write(timer.getTime(),"\n");
      if(forcedDiscard == true) then
         FILEsave:write(1);
      else
         FILEsave:write(0);
      end;

      -- closing file
      FILEsave:write("\n");   -- for unexpected errors do one more empty line
      FILEsave:close();
   end;
end;

function destroySaveGame()
   local FILEsave = io.open("save.lua","w+");
   FILEsave:write("no save game\n");
   FILEsave:close();
end;

function loadGame()
   --io.read(format"r"): variant;
   --Reads the input file according to a given format.
   --"*n": reads a number
   --"*a": reads the whole file
   --"*l": reads the next line
   --integer: reads a string with up to number of characters

   -- opening file
   local FILEsave = io.open("save.lua","r");
   --print(FILEsave);

   -- succeded in opening file?
   if (FILEsave ~= nil) then
   
      local readData = nil;   -- buffer of line
      local numBuffer = nil;  -- number buffer of line
      
      -- loading player stats
      readData = FILEsave:read("*l");--player stats
      print(readData);
      if(readData ~= "Player stats") then
         FILEsave:close();
         return(false);
      end;
      
      readData = FILEsave:read("*l");--data
      numBuffer = {};
      for i in string.gmatch(readData,"%d+") do
         table.insert(numBuffer,table.maxn(numBuffer)+1, tonumber(i));
      end;
      player.quary = numBuffer[1];
      player.bricks = numBuffer[2];
      player.magic = numBuffer[3];
      player.crystals = numBuffer[4];
      player.dungeon = numBuffer[5];
      player.recruits = numBuffer[6];
      player.wall = numBuffer[7];
      player.tower = numBuffer[8];
      
      -- loading enemy stats
      readData = FILEsave:read("*l");--enemy stats
      readData = FILEsave:read("*l");--data
      numBuffer = {};
      for i in string.gmatch(readData,"%d+") do
         table.insert(numBuffer,table.maxn(numBuffer)+1, tonumber(i));
      end;
      enemy.quary = numBuffer[1];
      enemy.bricks = numBuffer[2];
      enemy.magic = numBuffer[3];
      enemy.crystals = numBuffer[4];
      enemy.dungeon = numBuffer[5];
      enemy.recruits = numBuffer[6];
      enemy.wall = numBuffer[7];
      enemy.tower = numBuffer[8];
      
      -- rules
      readData = FILEsave:read("*l");--rules
      readData = FILEsave:read("*l");--data
      numBuffer = {};
      for i in string.gmatch(readData,"%d+") do
         table.insert(numBuffer,table.maxn(numBuffer)+1, tonumber(i));
      end;
      rules.tavern = numBuffer[1];
      if(rules.tavern < 1 or rules.tavern > #taverns.taverns) then  --is it uncommon settings, not specified tavern
         rules.maxTower = numBuffer[2];
         rules.maxWall = numBuffer[3];
         rules.maxResources = numBuffer[4];
         rules.numCards = numBuffer[5];
         rules.enemyTactics = numBuffer[6];
      else  -- load presets
         taverns.loadTavernRules(rules, rules.tavern);
      end;

      -- hand of player
      readData = FILEsave:read("*l");--Cards in player hand
      numBuffer = {};
      for line = 1,rules.numCards do
         readData = FILEsave:read("*l");--data
         numBuffer[line]={};
         local first = true   -- if true number is set orherwise it is ind
         for i in string.gmatch(readData,"%d+") do
            if(first == true) then
               numBuffer[line].set = tonumber(i);
               first = false;
            else
               numBuffer[line].ind = tonumber(i);
               first = true;
            end
    	   end;
  	   end;
  	   playerHand = numBuffer;

      -- hand of enemy
      readData = FILEsave:read("*l");--Cards in enemy hand
      numBuffer = {};
      for line = 1,rules.numCards-1 do
         readData = FILEsave:read("*l");--data
         numBuffer[line]={};
         local first = true   -- if true number is set orherwise it is ind
         for i in string.gmatch(readData,"%d+") do
            if(first == true) then
               numBuffer[line].set = tonumber(i);
               first = false;
            else
               numBuffer[line].ind = tonumber(i);
               first = true;
            end
    	   end;
  	   end;
  	   enemyHand = numBuffer;

      -- miscelanous
      readData = FILEsave:read("*l");--Miscelanous
      moves = tonumber(FILEsave:read("*l"));
      local timeExtra = tonumber(FILEsave:read("*l"));
  	   timer.addExtraTime(timeExtra);
  	   
  	   readData = FILEsave:read("*l");
      if(tonumber(readData) == 1) then
         forcedDiscard = true;
      else
         forcedDiscard = false;
      end;

      -- closing file
      FILEsave:close();
      
      -- loaded
      return(true);
   end;
   
   -- bad save, couldnt open file
   return(false);
end;

function materialAddition(who)
   who.bricks = who.bricks + who.quary;
   who.crystals = who.crystals + who.magic;
   who.recruits = who.recruits+ who.dungeon;
end;

function materialCheck(player, enemy, rules)
   -- player
   if(player.quary < 0) then player.quary = 0; end;
   if(player.bricks < 0) then player.bricks = 0; end;
   if(player.magic < 0) then player.magic = 0; end;
   if(player.crystals < 0) then player.crystals = 0; end;
   if(player.dungeon < 0) then player.dungeon = 0; end;
   if(player.recruits < 0) then player.recruits = 0; end;
   if(player.wall < 0) then player.wall = 0; end;
   if(player.wall > rules.maxWall) then player.wall = rules.maxWall; end;
   if(player.tower < 0) then player.tower = 0; end;
   
   -- enemy
   if(enemy.quary < 0) then enemy.quary = 0; end;
   if(enemy.bricks < 0) then enemy.bricks = 0; end;
   if(enemy.magic < 0) then enemy.magic = 0; end;
   if(enemy.crystals < 0) then enemy.crystals = 0; end;
   if(enemy.dungeon < 0) then enemy.dungeon = 0; end;
   if(enemy.recruits < 0) then enemy.recruits = 0; end;
   if(enemy.wall < 0) then enemy.wall = 0; end;
   if(enemy.wall > rules.maxWall) then enemy.wall = rules.maxWall; end;
   if(enemy.tower < 0) then enemy.tower = 0; end;
end;

function victoryConditionCheck(player, enemy, rules)
   -- game over
   win = nil;

   -- enemy victory
   if(enemy.tower >= rules.maxTower) then win = "You were defeated by enemy tower size"; end;
   if(player.tower <= 0) then win = "You were defeated by tower destruction"; end;
   if(enemy.bricks >= rules.maxResources
   and enemy.crystals >= rules.maxResources
   and enemy.recruits >= rules.maxResources) then win = "You were defeated by resources dominance"; end;

   -- player victory
   if(player.tower >= rules.maxTower) then win = "You won by tower size"; end;
   if(enemy.tower <= 0) then win = "You won by tower destruction"; end;
   if(player.bricks >= rules.maxResources
   and player.crystals >= rules.maxResources
   and player.recruits >= rules.maxResources) then win = "You won by resources dominance"; end;

   return(win);
end;

function render()
   -- render all
   field.renderField(player, enemy);
	field.renderTowersAndWalls(player, enemy, rules);
	cards.renderCards(playerHand, player);
   -- except selected cards
end;

function playGame()

--   timeOfStart = os.time(); -- match begun

   while true do
   -- some controll event
  	if(control.read()==1) then
  	    -- touch screen event
  		if(control.isTouch()==1) then
  			if(touch.click()==1) then
  				x,y = touch.pos()
              --print(focusedCard);
              if(y < 155) then  -- card action
                 if(forcedDiscard == true) then  -- is forced to discard
                    local discarded = cards.focusedCardForcedDiscard(playerHand, focusedCard, player, enemy, x ,y);
                    focusedCard = 0;
                    if(discarded == true) then
                       forcedDiscard = false;-- after forced discard player always continues
                       cards.randomFillHandToFull(playerHand, rules.numCards);
                    end;
                 else  -- not forced to discard
                     local action = cards.focusedCardAction(playerHand, focusedCard, player, enemy, x ,y);
                     --print("akce", action);

                     if(action == 0) then       -- 0 no action, continue
                        focusedCard = 0;
                     elseif(action == 1) then   -- 1 played or discarded, end round
                        focusedCard = 0;
                        roundEnd = true;
                          moves = moves +1;
                     elseif(action == 2) then   -- 2 played, continue
                        focusedCard = 0;
                        cards.randomFillHandToFull(playerHand, rules.numCards);
                     else                       -- 3 select card to discard, continue
                        focusedCard = 0;
                        cards.randomFillHandToFull(playerHand, rules.numCards);
                        forcedDiscard = true;
                        print("forced discard");
                     end;

        				   -- recounting stuff
        				   materialCheck(player, enemy, rules);

                     -- checking victory conditions
        				   victory = victoryConditionCheck(player, enemy, rules);
                     if(victory ~= nil) then break; end;

                     -- ENEMY move
                     if(forcedDiscard == false and roundEnd == true) then

                        materialAddition(enemy);
                        cards.randomFillHandToFull(enemyHand, rules.numCards);

                          -- wait for reaction
                          render();
                          screen.update();
                          os.wait(500);

                          -- counteraction till finished
                          while roundEnd == true do
                             -- returned cards
                             local ePlayed = false;
                             local eCard = nil;

                             -- play
                             if(rules.enemyTactics == 0) then       -- random card
                                ePlayed, roundEnd, eCard = cards.enemyRandomMove(enemyHand, enemy, player, rules);
                             elseif(rules.enemyTactics == 1) then   -- agresive
                                ePlayed, roundEnd, eCard = cards.enemyAgresiveMove(enemyHand, enemy, player, rules);
                             else                                   -- defensive
                                ePlayed, roundEnd, eCard = cards.enemyDefensiveMove(enemyHand, enemy, player, rules);
                             end;

                             -- material
                             materialCheck(player, enemy, rules);

                             -- render enemy played card (card played or discarded)
                             render();
                             cards.renderEnemyMove(ePlayed, eCard);
                             screen.update();
                             os.wait(enemyShowTime);

                             -- if forced to discard,do it (prism or elven scout played)
                             if(ePlayed == true and eCard.discarding == true) then
                                -- get cards
                                cards.randomFillHandToFull(enemyHand, rules.numCards);

                                -- discard
                                eCard = cards.enemyRandomDiscard(enemyHand, enemy);
                                ePlayed = false;

                                -- render enemy played card
                                render();
                                cards.renderEnemyMove(ePlayed, eCard);
                                screen.update();
                                os.wait(enemyShowTime);
                             end

                          end;

                        -- checking winner
                        victory = victoryConditionCheck(player, enemy, rules);
                        if(victory ~= nil) then break; end;

                          -- prepairing hand for player
                        materialAddition(player);
                        cards.randomFillHandToFull(playerHand, rules.numCards);
                        roundEnd = false;
                     end;
                 end;
  				else    -- card selection
                 focusedCard = cards.selectCard(playerHand, x, y);
  				end;
  			end;
  		-- player buttom has been pressed
  		elseif control.isButton()==1 then
  		    -- player home buttom event
  		    -- and home button has been clicked
  			if(button.home() == 1) then
            if(button.click()==1) then

               -- stop timer
               timer.pause();
               local retsavemenu = gamemenus.saveMenuLoop(timer.getTime(),moves,rules);

               if(retsavemenu == 1) then
                  saveGame();
                  break;
               elseif(retsavemenu == 2) then
                  break;
               end
               
               -- continue timer
               timer.continue();
  				end;
  			end;
  		end;
   else

  	-- draw
   render();

   -- draw selcted cards
   if(forcedDiscard == false) then  -- NORMAL MODE
      cards.renderFocusedCardFromHand(playerHand, focusedCard, player);
  	else    -- FORCED DISCARD
      cards.renderDiscardFocusedCardFromHand(playerHand, focusedCard, player);
  	end;

  	-- change back buffer to front
  	screen.update();

  	-- spare some time for other programs
  	os.wait(100);
  	end;
   end;

   --victorious
   if(victory ~= nil) then
      gamemenus.showEndGame(victory, timer.getTime(), moves);
      --highscore?
      victory = nil;
   end;
end;

--------------------------[menu]--------------------------------
local game = true;   -- as long it is true game plays
local menuLoop = true;   -- as long it is true game plays
while (menuLoop == true) do
   if(control.read()==1) then
	    -- touch screen event
		if(control.isTouch()==1) then
			if(touch.click()==1) then
				x,y = touch.pos()
				returnedButton = gamemenus.mainMenuFunction(x,y);

            if(returnedButton == 1) then  -- new game
               -- selecting tavern
               local tav = nil;
               while(tav == nil) do
                  if(control.read()==1) then
                     if(control.isTouch()==1) then
                        if(touch.click()==1) then
                           x,y = touch.pos()
                           tav = gamemenus.newGameMenuFunction(x,y);
                        end;
                     end;
                  else
                  
                  gamemenus.newGameMenuRender();
                  screen.update();
	               os.wait(100);
                  end;
               end;
               
               if(tav > 0) then -- recieved really index of tavern?
               
                  timer.reset();
                  taverns.loadTavernSettings(player, enemy, rules, tav);   --9
                  playerHand = {};
                  enemyHand = {};
                  cards.randomFillHandToFull(playerHand, rules.numCards);
                  cards.randomFillHandToFull(enemyHand, rules.numCards-1);
                  moves = 0;
                  timer.continue();
                  playGame();
               end;
				end
				if(returnedButton == 2) then -- load game
               timer.reset();
               local loadedGood = loadGame();
               if(loadedGood == false) then  -- game coudnt be loaded
                  gamemenus.loadMenuLoop();  -- no valid savegame
               else     -- game loaded
                  destroySaveGame();
                  timer.continue();
                  playGame();
               end;
				end
				if(returnedButton == 3) then
               gamemenus.showInstructions();
				end
				if(returnedButton == 4) then
               --gamemenus.showHighscore();
				end
				if(returnedButton == 6) then
               break;
				end
				
			end;
      else
         if(button.home() == 1) then
            if(button.click()==1) then
               game = false;
               break;
            end;
         end;
		end;
	else
	
   gamemenus.mainMenuRender();
   screen.update();

   -- spare some time for other programs
	os.wait(100);

   end;
end;

-------------------------[clearing images]-----------------------
os.wait(100)
cards.closeCards();
gamemenus.closeImages();
field.closeFieldImages();
