--[[
rewritten in lua by Delirius
3.4.2010
version 0.9.6
(for Creative zen X-FI 2 only)

This remake isnt intended for making profit
If you paid for it, you were scammed.
Go and demand your money back.

------------------(original authors)-----------------------
New World Computing (division of The 3DO Company)

Executive Producer: Mark Caldwell
Programming: James R. Morris II, Bob Young, George Ruof
Testing: Karl Drown, Eric Williamson, Joseph Burton, Todd Smailes, Ernie Gallardo
Producer: Peter Ryu
Art: William Chow, Steve Jasper

3DO, Arcomage, New World Computing, and their respective logos
are trademarks and/or service marks of their respective owners.
]]--


module(...,package.seeall);

-- ai:
-- 0 = random
-- 1 = agresive
-- 2 = defensive

-- tavern definitions
taverns =
{
{name="On the house", location="Harmondale", tower=15, maxTower=30, wall=5, maxResources=100, quary=2, bricks=10, magic=2, crystals=10, dungeon=2, recruits=10, cards=5, ai=0},
{name="griffin's rest", location="Erathia", tower=20, maxTower=50, wall=5, maxResources=150, quary=2, bricks=5, magic=2, crystals=5, dungeon=2, recruits=5, cards=5, ai=2},
{name="Emerald Inn", location="Turalean Forest", tower=20, maxTower=50, wall=5, maxResources=150, quary=2, bricks=5, magic=2, crystals=5, dungeon=2, recruits=5, cards=5, ai=1},
{name="Snobbish Goblin", location="Deyja", tower=25, maxTower=75, wall=10, maxResources=200, quary=3, bricks=5, magic=3, crystals=5, dungeon=3, recruits=5, cards=5, ai=1},
{name="Familiar Place", location="Bracada Desert", tower=20, maxTower=75, wall=10, maxResources=200, quary=3, bricks=5, magic=3, crystals=5, dungeon=3, recruits=5, cards=7, ai=2},
{name="The Blessed Brew", location="Celeste", tower=30, maxTower=100, wall=15, maxResources=300, quary=4, bricks=10, magic=4, crystals=10, dungeon=4, recruits=10, cards=7, ai=2},
{name="The Vampyre Lounge", location="The Pit", tower=30, maxTower=100, wall=15, maxResources=300, quary=4, bricks=10, magic=4, crystals=10, dungeon=4, recruits=10, cards=7, ai=1},
{name="The Laughing Monk", location="Evermorn Island", tower=20, maxTower=150, wall=10, maxResources=400, quary=5, bricks=25, magic=2, crystals=25, dungeon=5, recruits=25, cards=7, ai=0},
{name="Fortune's Folly", location="Nighon", tower=20, maxTower=200, wall=10, maxResources=500, quary=1, bricks=15, magic=1, crystals=15, dungeon=1, recruits=15, cards=7, ai=1},
{name="Miner's Only", location="Barrow Downs", tower=20, maxTower=100, wall=50, maxResources=300, quary=1, bricks=5, magic=1, crystals=5, dungeon=5, recruits=25, cards=7, ai=0},
{name="The Loyal Mercenary", location="Tidewater", tower=10, maxTower=125, wall=20, maxResources=350, quary=3, bricks=15, magic=1, crystals=5, dungeon=2, recruits=10, cards=7, ai=1},
{name="The Potted Pixie", location="Avlee", tower=10, maxTower=125, wall=20, maxResources=350, quary=3, bricks=15, magic=1, crystals=5, dungeon=2, recruits=10, cards=7, ai=2},
{name="Grogg's Grog", location="Stone City", tower=50, maxTower=100, wall=50, maxResources=300, quary=5, bricks=20, magic=3, crystals=10, dungeon=5, recruits=20, cards=7, ai=0}
}

function loadTavernSettings(player, enemy, rules, index)
   -- exists tavern of such index
   if(index > #taverns or index < 1) then
      print("no such a tavern");
      return;
   end;

   -- player = {quary = 2, bricks = 10, magic = 2, crystals = 10, dungeon = 2, recruits = 10, wall = 10, tower = 20};
   -- enemy  = {quary = 2, bricks = 10, magic = 2, crystals = 10, dungeon = 2, recruits = 10, wall = 10, tower = 20};
   -- rules  = {tavern=0, maxTower = 50, maxWall = 100, maxResources = 100, numCards=6, enemyTactics=0};

   -- loadt it
   local tavern = taverns[index];
   
   -- change rules
   rules.tavern = index;
   rules.maxTower = tavern.maxTower;
   rules.maxWall = 100;
   rules.maxResources = tavern.maxResources;
   rules.numCards = tavern.cards + 1;
   rules.enemyTactics = tavern.ai;
   
   -- tower and wall
   player.tower = tavern.tower;
   enemy.tower = tavern.tower;
   player.wall = tavern.wall;
   enemy.wall = tavern.wall;
   
   -- change starting resources
   player.quary = tavern.quary;
   player.bricks = tavern.bricks;
   player.magic = tavern.magic;
   player.crystals = tavern.crystals;
   player.dungeon = tavern.dungeon;
   player.recruits = tavern.recruits;
   
   enemy.quary = tavern.quary;
   enemy.bricks = tavern.bricks;
   enemy.magic = tavern.magic;
   enemy.crystals = tavern.crystals;
   enemy.dungeon = tavern.dungeon;
   enemy.recruits = tavern.recruits;
end;

function loadTavernRules(rules, index)
   -- exists tavern of such index
   if(index > #taverns or index < 1) then
      print("no such a tavern");
      return;
   end;

   -- rules  = {tavern=0, maxTower = 50, maxWall = 100, maxResources = 100, numCards=6, enemyTactics=0};

   -- loadt it
   local tavern = taverns[index];

   -- change rules
   rules.tavern = index;
   rules.maxTower = tavern.maxTower;
   rules.maxWall = 100;
   rules.maxResources = tavern.maxResources;
   rules.numCards = tavern.cards + 1;
   rules.enemyTactics = tavern.ai;
end;
