--[[
written in lua by Delirius
10.4.2010
version 1.0.0

timer for getting how many seconds have passed from certain moment
]]--

module(...,package.seeall);


-----------------------[variables of timer]----------------------------

local timeOfStart = 0;        -- time when timer started
local timeExtra = 0;          -- extra time for remembering time before pause
local timeRunning = false;    -- is timer currently counting time

-----------------------[functions of timer]----------------------------
-- resets and stops timer (time = 0)
function reset()
   timeOfStart = 0;
   timeExtra = 0;
   timeRunning = false;
end;

-- pauses timer remembering time from start
function pause()
   if(timeRunning == true) then
      timeExtra = getTime();  -- saving time passed was till now
      timeRunning = false;    -- stopping it
   end;
end;

-- making timer count again after pause (remembering used time)
function continue()
   if(timeRunning ~= true) then
      timeOfStart = os.time();
      timeRunning = true;
   end;
end;

-- adds some time to timer making it seem, it ran longer
function addExtraTime(extra)
   timeExtra = timeExtra + extra;
end;

-- gets current time on timer since starting it
function getTime()
   if(timeRunning == true) then  -- it runs
      return(timeExtra + os.time() - timeOfStart);
   else  -- it is paused
      return(timeExtra);
   end;
end;
